#ifndef REVERSI_BOARD_H_INCLUDED
#define REVERSI_BOARD_H_INCLUDED

#include "disc.h"
#include <stack>

//=============================================================================
// Q[
//=============================================================================
class Board {
public:
	// Q[Ղ̃TCY
	static const int SIZE = 8;
	// }X̑傫(pixel)
	static const int CELL_SIZE = 64;
	// ΂̔a(pixel)
	static const int RADIUS = 24;
	// wi̐F
	static const COLORREF BACKGROUND_COLOR = RGB(63, 159, 111);
	// (pixel)
	static const int WIDTH = (SIZE + 0.5) * (CELL_SIZE / 2.0) * 1.732;
	// (pixel)
	static const int HEIGHT = SIZE * (CELL_SIZE / 2.0) * 1.5 + (CELL_SIZE / 4.0);

	// RXgN^
	Board(int x, int y);

	// Rs[RXgN^
	Board(const Board& board);

	// fXgN^
	~Board();

	// Zbg
	void reset();

	// (x, y)ɂ΂擾
	Disc* get(int x, int y) { return discs[x][y]; }
	const Disc* get(int x, int y) const { return discs[x][y]; }

	// (x, y) disc u
	// uƂłꍇ true Ԃ
	bool put(int x, int y, Disc* disc);

	// (x, y) disc uꍇAtrue Ԃ
	bool canPut(int x, int y, Disc* disc) const;

	// `悷
	void draw(HDC hdc);

	// W擾
	int getX() const { return location.x; }
	int getY() const { return location.y; }

	// (x, y) disc uƂɁAԂƂ̂ł΂̐擾
	int getReversibleDiscCount(int x, int y, Disc* disc) const;

	int getTurn() const { return turn; }
	Disc* getTurnDisc() const { return turn % 2 == 0 ? Disc::black() : Disc::white(); }

	// pX
	void pass() { ++turn; }

	// ߂
	void undo();

private:
	struct UndoData {
		int turn;
		POINT p0;     // ΂uꂽ_
		POINT p[8];   // Ԃ̓_
	};

	int turn;
	Disc* discs[SIZE][SIZE];
	POINT location;
	HBRUSH hBackgroundBrush;
	std::stack<UndoData> undoBuffer;
};

#endif
