#include "stdafx.h"
#include "controller.h"
#include "resource.h"

LPCTSTR lpszClassName  = TEXT("nHexReversi");
LPCTSTR lpszWindowName = TEXT("Zpo[V");

//-----------------------------------------------------------------------------
// EBhEvV[W
//-----------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static Controller* controller;

	switch (message) {
	case WM_CREATE:
		controller = new Controller(hWnd);
		return 0L;

	case WM_PAINT:
		controller->onPaint(hWnd);
		return 0L;

	case WM_LBUTTONUP:
		controller->onLButtonUp(hWnd, LOWORD(lParam), HIWORD(lParam));
		return 0L;

	case WM_COMMAND:
		controller->onCommand(hWnd, LOWORD(wParam), (HWND)lParam);
		return 0L;

	case WM_DESTROY:
		delete controller;
		PostQuitMessage(0);
		return 0L;
	}

	return DefWindowProc(hWnd, message, wParam, lParam);
}

//-----------------------------------------------------------------------------
// EBhENXo^
// ꍇtrueԂ
//-----------------------------------------------------------------------------
bool RegisterWindowClass(HINSTANCE hInstance)
{
	WNDCLASS wc;

	wc.style         = 0;
	wc.lpfnWndProc   = WindowProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
	wc.lpszClassName = lpszClassName;

	return RegisterClass(&wc) != NULL;
}

//-----------------------------------------------------------------------------
// CEBhEA\
// ꍇtrueԂ
//-----------------------------------------------------------------------------
bool SetupWindow(HINSTANCE hInstance, int nCmdShow)
{
	DWORD windowStyle = WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX;

	// EBhẼTCYvZ
	RECT sizeRect = {
		0, 0,
		Board::WIDTH + StatusDisplay::WIDTH + 30,
		Board::HEIGHT + 20
	};
	AdjustWindowRect(&sizeRect, windowStyle, TRUE);
	SIZE size = {
		sizeRect.right - sizeRect.left,
		sizeRect.bottom - sizeRect.top
	};

	// EBhEʒɗ悤ɍWvZ
	SIZE desktopSize = {
		GetSystemMetrics(SM_CXSCREEN),
		GetSystemMetrics(SM_CYSCREEN)
	};
	POINT pos = {
		(desktopSize.cx - size.cx) / 2,
		(desktopSize.cy - size.cy) / 2
	};

	// EBhE
	HWND hWnd = CreateWindow(
		lpszClassName, lpszWindowName, windowStyle,
		pos.x, pos.y, size.cx, size.cy,
		NULL, NULL, hInstance, NULL
	);

	if (hWnd) {
		ShowWindow(hWnd, nCmdShow);
		UpdateWindow(hWnd);
		return true;
	} else {
		return false;
	}
}

//-----------------------------------------------------------------------------
// C֐
//-----------------------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	if (!RegisterWindowClass(hInstance))
		return 0;

	if (!SetupWindow(hInstance, nCmdShow))
		return 0;

	MSG msg;

	while (GetMessage(&msg, NULL, 0, 0) > 0) {
		DispatchMessage(&msg);
	}

	return (int)msg.wParam;
}
