#ifndef REVERSI_COM_H_INCLUDED
#define REVERSI_COM_H_INCLUDED

#include "board.h"
#include "disc.h"

//=============================================================================
// Com
//=============================================================================
class ICom {
public:
	virtual ~ICom() {};
	virtual POINT think() = 0;
	virtual Disc* getDisc() = 0;
	virtual void setDisc(Disc*) = 0;
	virtual LPCTSTR getName() = 0;
};

//=============================================================================
// _ɒu
//=============================================================================
class RandomCom : public ICom {
public:
	RandomCom(Board* board, Disc* disc);

	POINT think();

	Disc* getDisc() { return disc; }
	void setDisc(Disc*);

	LPCTSTR getName() {
		return TEXT("Random");
	}

private:
	Board* board;
	Disc* disc;
};

//=============================================================================
// ԑƂɒu
//=============================================================================
class MaxCom : public ICom {
public:
	MaxCom(Board* board, Disc* disc);

	POINT think();

	Disc* getDisc() { return disc; }
	void setDisc(Disc*);

	LPCTSTR getName() {
		return TEXT("Max");
	}

private:
	Board* board;
	Disc* disc;
};

//=============================================================================
//
//=============================================================================
class AlphaCom : public ICom {
public:
	AlphaCom(Board* board, Disc* disc);

	POINT think();

	Disc* getDisc() { return disc; }
	void setDisc(Disc*);

	LPCTSTR getName() {
		return TEXT("Alpha");
	}

private:
	int alphabeta(int depth, int alpha, int beta);
	int eval();

	Board* board;
	Disc* disc;
};

#endif
