#include "stdafx.h"
#include "statusdisplay.h"

//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
StatusDisplay::StatusDisplay(int x, int y, const Board* board)
	: x(x), y(y), board(board), turn(0), win(NULL), gameover(false)
{
}

//-----------------------------------------------------------------------------
// ԂXV
//-----------------------------------------------------------------------------
void StatusDisplay::update(int turn, ICom* com, bool gameover, Disc* win)
{
	this->turn = turn;
	this->gameover = gameover;
	this->win = win;
	this->com = com;
}

//-----------------------------------------------------------------------------
// `悷
//-----------------------------------------------------------------------------
void StatusDisplay::draw(HDC hdc)
{
	// ΂Ɣ΂̐𐔂
	int blackCount = 0, whiteCount = 0;

	for (int i = 0; i < Board::SIZE; ++i) {
		for (int j = 0; j < Board::SIZE; ++j) {
			const Disc* disc = board->get(i, j);
			if (disc == Disc::black())
				++blackCount;
			else if (disc == Disc::white())
				++whiteCount;
		}
	}

	// g`
	SelectObject(hdc, GetStockObject(BLACK_PEN));
	SelectObject(hdc, GetStockObject(WHITE_BRUSH));
	Rectangle(hdc, x, y, x + WIDTH, y + HEIGHT);

	// Ԃ\
	TCHAR buffer[256];
	RECT rect = {
		x + PADDING, y + PADDING,
		x + WIDTH - PADDING, y + HEIGHT - PADDING
	};

	if (gameover) {
		if (win == NULL) {
			wsprintf(
				buffer, TEXT("ł\n%d ŏI\n Human\n    %d \n %s\n    %d "),
				turn, blackCount, com ? com->getName() : TEXT("Human"), whiteCount
			);
		} else {
			wsprintf(
				buffer, TEXT("%s̏ł\n%d ŏI\n Human\n    %d \n %s\n    %d "),
				Disc::toString(win), turn, blackCount, com ? com->getName() : TEXT("Human"), whiteCount
			);
		}
	} else {
		wsprintf(
			buffer, TEXT("%s̔Ԃł\n%d \n Human\n    %d \n %s\n    %d "),
			turn % 2 == 0 ? TEXT("") : TEXT(""), turn+1, blackCount, com ? com->getName() : TEXT("Human"), whiteCount
		);
	}

	SelectObject(hdc, GetStockObject(BLACK_PEN));
	SelectObject(hdc, GetStockObject(NULL_BRUSH));
	DrawText(hdc, buffer, -1, &rect, DT_LEFT);
}
